unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ToolWin, ComCtrls;

type
  TForm1 = class(TForm)
    CoolBar1: TCoolBar;
    ComboBox1: TComboBox;
    Panel1: TPanel;
    Button1: TButton;
    LblPath: TLabel;
    Image1: TImage;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FStrBuf: TStringList;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    StrUtils;

//-----------------------------------------------------------------------------
//  GetTextMetricsW
function ExecGetTextMetrics(const DC: HDC; var TextMetric: TTextMetricW; var Err: String): Boolean;
begin
    //  \̏
    FillChar(TextMetric, SizeOf(TextMetric), 0);
    //  GetTextMetricsW
    Result := GetTextMetricsW(DC, TextMetric);
    if (not Result) then Err := SysErrorMessage(GetLastError());
end;

//------------------------------------------------------------------------------
//  䕶`FbN
function IsCtrlChar(const c: WideChar): Boolean;
begin
    Result := (Ord(c) in [$0000..$001F, $007F]);
end;

//-----------------------------------------------------------------------------
//  FormCreate
procedure TForm1.FormCreate(Sender: TObject);
begin
    FStrBuf := TStringList.Create();

    //  tHg̈ꗗ擾
    ComboBox1.Items.Assign(Screen.Fonts);
    //  Ƃ肠tH[ɐݒ肳ĂtHgI
    ComboBox1.ItemIndex := ComboBox1.Items.IndexOf(Self.Font.Name);
    ComboBox1Change(ComboBox1);
    //  o̓pX
    LblPath.Caption := ChangeFileExt(ParamStr(0), '.txt');
end;

//-----------------------------------------------------------------------------
//  FormDestroy
procedure TForm1.FormDestroy(Sender: TObject);
begin
    FStrBuf.Free();
end;

//-----------------------------------------------------------------------------
//  tHgI
//  Delphi Win32 Graphics API t@X p671-678
//  Subject: [Delphi:81289] Re: jR[h̎擾@
procedure TForm1.ComboBox1Change(Sender: TObject);
const
    FONT_WEIGHT: array[0..9] of String
    = ('FW_DONTCARE', 'FW_THIN', 'FW_EXTRALIGHT', 'FW_LIGHT', 'FW_NORMAL',
       'FW_MEDIUM', 'FW_SEMIBOLD', 'FW_BOLD', 'FW_EXTRABOLD', 'FW_HEAVY');
var
    LTextMetrics: TTextMetricW;
    LErr: String;
    LChar: WideChar;
    LText: String;
    LValue: String;
    LIntValue: Integer;
begin
    Self.Font.Name := ComboBox1.Text;

    if (ExecGetTextMetrics(Self.Canvas.Handle, LTextMetrics, LErr)) then
    begin
        Memo1.Clear();

        //  tmHeight
        LText := Format('%s = %d', ['tmHeight', LTextMetrics.tmHeight]);

        //  tmAscent
        Memo1.Lines.Add(LText);
        LText := Format('%s = %d', ['tmAscent', LTextMetrics.tmAscent]);

        //  tmInternalLeading
        Memo1.Lines.Add(LText);
        LText := Format('%s = %d', ['tmInternalLeading', LTextMetrics.tmInternalLeading]);

        //  tmExternalLeading
        Memo1.Lines.Add(LText);
        LText := Format('%s = %d', ['tmExternalLeading', LTextMetrics.tmExternalLeading]);

        //  tmAveCharWidth
        Memo1.Lines.Add(LText);
        LText := Format('%s = %d', ['tmAveCharWidth', LTextMetrics.tmAveCharWidth]);

        //  tmMaxCharWidth
        Memo1.Lines.Add(LText);
        LText := Format('%s = %d', ['tmMaxCharWidth', LTextMetrics.tmMaxCharWidth]);
        Memo1.Lines.Add(LText);

        //  tmWeight
        LIntValue := LTextMetrics.tmWeight;
        case (LIntValue div 100) of
            0..9: LText := FONT_WEIGHT[LIntValue div 100];
            else  LText := 'UNKNOWN'; 
        end;
        LText := Format('%s = [%s] %d', ['tmWeight', LText, LTextMetrics.tmWeight]);
        Memo1.Lines.Add(LText);

        //  tmOverhang
        LText := Format('%s = %d', ['tmOverhang', LTextMetrics.tmOverhang]);
        Memo1.Lines.Add(LText);

        //  tmDigitizedAspect
        LText := Format('%s = (%d,%d)', ['tmDigitizedAspect', LTextMetrics.tmDigitizedAspectX, LTextMetrics.tmDigitizedAspectY]);
        Memo1.Lines.Add(LText);

        //  tmFirstChar
        LChar := LTextMetrics.tmFirstChar;
        if (IsCtrlChar(LChar)) then LText := ' ' else LText := LChar;
        LValue := '$' + IntToHex(Ord(LChar), 4);
        LText := Format('%s = [%s] (%s)', ['tmFirstChar', LText, LValue]);
        Memo1.Lines.Add(LText);

        //  tmLastChar
        LChar := LTextMetrics.tmLastChar;
        if (IsCtrlChar(LChar)) then LText := ' ' else LText := LChar;
        LValue := '$' + IntToHex(Ord(LChar), 4);
        LText := Format('%s = [%s] (%s)', ['tmLastChar', LText, LValue]);
        Memo1.Lines.Add(LText);

        //  tmDefaultChar
        LChar := LTextMetrics.tmDefaultChar;
        if (IsCtrlChar(LChar)) then LText := ' ' else LText := LChar;
        LValue := '$' + IntToHex(Ord(LChar), 4);
        LText := Format('%s = [%s] (%s)', ['tmDefaultChar', LText, LValue]);
        Memo1.Lines.Add(LText);

        //  tmBreakChar
        LChar := LTextMetrics.tmBreakChar;
        if (IsCtrlChar(LChar)) then LText := ' ' else LText := LChar;
        LValue := '$' + IntToHex(Ord(LChar), 4);
        LText := Format('%s = [%s] (%s)', ['tmBreakChar', LText, LValue]);
        Memo1.Lines.Add(LText);

        //  tmItalic
        LText := Format('%s = %d', ['tmItalic', LTextMetrics.tmItalic]);
        Memo1.Lines.Add(LText);

        //  tmUnderlined
        LText := Format('%s = %d', ['tmUnderlined', LTextMetrics.tmUnderlined]);
        Memo1.Lines.Add(LText);

        //  tmStruckOut
        LText := Format('%s = %d', ['tmStruckOut', LTextMetrics.tmStruckOut]);
        Memo1.Lines.Add(LText);

        //  tmPitchAndFamily - Pitch
        LIntValue := LTextMetrics.tmPitchAndFamily and $0F;
        FStrBuf.Clear();
        if (LIntValue and TMPF_FIXED_PITCH = TMPF_FIXED_PITCH) then FStrBuf.Add('FIXED_PITCH');
        if (LIntValue and TMPF_VECTOR = TMPF_VECTOR) then FStrBuf.Add('VECTOR');
        if (LIntValue and TMPF_TRUETYPE = TMPF_TRUETYPE) then FStrBuf.Add('TRUETYPE');
        if (LIntValue and TMPF_DEVICE = TMPF_DEVICE) then FStrBuf.Add('DEVICE');
        if (LIntValue = 0) then FStrBuf.Add('MONOSPACED_BITMAP_FONT');
        LValue := '$' + IntToHex(LIntValue, 2);
        Memo1.Lines.Add('tmPitchAndFamily and $0F = ');
        LText := Format(' [%s] (%s)', [FStrBuf.CommaText, LValue]);
        Memo1.Lines.Add(LText);

        //  tmPitchAndFamily - Family
        LIntValue := LTextMetrics.tmPitchAndFamily and $F0;
        case (LIntValue) of
            FF_DECORATIVE   : LText := 'FF_DECORATIVE';
            FF_DONTCARE     : LText := 'FF_DONTCARE';
            FF_MODERN       : LText := 'FF_MODERN';
            FF_ROMAN        : LText := 'FF_ROMAN';
            FF_SCRIPT       : LText := 'FF_SCRIPT';
            FF_SWISS        : LText := 'FF_SWISS';
            else              LText := 'UNKNOWN';
        end;
        LValue := '$' + IntToHex(LIntValue, 2);
        Memo1.Lines.Add('tmPitchAndFamily and $F0 = ');
        LText := Format(' [%s] (%s)', [LText, LValue]);
        Memo1.Lines.Add(LText);

        //  tmCharSet
        LIntValue := LTextMetrics.tmCharSet;
        case LIntValue of
            ANSI_CHARSET        : LText := 'ANSI_CHARSET';
            DEFAULT_CHARSET     : LText := 'DEFAULT_CHARSET';
            SYMBOL_CHARSET      : LText := 'SYMBOL_CHARSET';
            MAC_CHARSET         : LText := 'MAC_CHARSET(for Win95)';
            SHIFTJIS_CHARSET    : LText := 'SHIFTJIS_CHARSET';
            HANGEUL_CHARSET     : LText := 'HANGEUL_CHARSET';
            JOHAB_CHARSET       : LText := 'JOHAB_CHARSET(for Win95)';
            GB2312_CHARSET      : LText := 'GB2312_CHARSET';
            CHINESEBIG5_CHARSET : LText := 'CHINESEBIG5_CHARSET';
            GREEK_CHARSET       : LText := 'KGREEK_CHARSET(for Win95)';
            TURKISH_CHARSET     : LText := 'TURKISH_CHARSET(for Win95)';
            VIETNAMESE_CHARSET  : LText := 'VIETNAMESE_CHARSET(for Win95)';
            HEBREW_CHARSET      : LText := 'HEBREW_CHARSET(for Win95)';
            ARABIC_CHARSET      : LText := 'ARABIC_CHARSET(for Win95)';
            BALTIC_CHARSET      : LText := 'BALTIC_CHARSET(for Win95)';
            RUSSIAN_CHARSET     : LText := 'RUSSIAN_CHARSET(for Win95)';
            THAI_CHARSET        : LText := 'THAI_CHARSET';
            EASTEUROPE_CHARSET  : LText := 'EASTEUROPE_CHARSET(for Win95)';
            OEM_CHARSET         : LText := 'OEM_CHARSET';

            else            
        end;
        LText := Format('%s = [%s] (%d)', ['tmCharSet', LText, LIntValue]);
        Memo1.Lines.Add(LText);
    end
    else Memo1.Lines.Add(LErr);
end;

//-----------------------------------------------------------------------------
//  `Ă镶o
procedure TForm1.Button1Click(Sender: TObject);
var
    LStream: TFileStream;
    LTextMetrics: TTextMetricW;
    LErr: String;
    i: WideChar;
begin
    Self.Font.Name := ComboBox1.Text;

    if (ExecGetTextMetrics(Self.Canvas.Handle, LTextMetrics, LErr)) then
    begin
        LStream := nil;
        try
            LStream := TFileStream.Create(LblPath.Caption, fmCreate or fmShareDenyWrite);
            try
                for i := LTextMetrics.tmFirstChar to LTextMetrics.tmLastChar do
                begin
                    if (IsCtrlChar(i)) then Continue;
                    LStream.Write(i, SizeOf(i));
                end;
            finally
                LStream.Free();
            end;
        except
            on E: Exception do Memo1.Lines.Add(E.Message);
        end;
    end
    else Memo1.Lines.Add(LErr);
end;

end.
